//+------------------------------------------------------------------+
//|                                                  DayBreakout.mq4 |
//|                                                        Bill Sica |
//|                                         http://www.tetsuyama.com |
//+------------------------------------------------------------------+
#property copyright "Bill Sica"
#property link      "http://www.tetsuyama.com"

#property indicator_chart_window
//---- input parameters
extern int DAYS=1;
extern color HighColor=SpringGreen;
extern color LowColor=SandyBrown;
extern int HighStyle=2;
extern int LowStyle=2;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
  {
//---- indicators

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   Comment("");
   ObjectDelete("DayHigh");
   ObjectDelete("DayLow");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double daily_high[20];
   double daily_low[20];
   double phigh,plow;
   int i=1;

ArrayResize(daily_high,DAYS);
ArrayResize(daily_low,DAYS);
ArrayInitialize(daily_high,0);
ArrayInitialize(daily_low,0);

ArrayCopySeries(daily_low, MODE_LOW, Symbol(), PERIOD_D1);
ArrayCopySeries(daily_high, MODE_HIGH, Symbol(), PERIOD_D1);

/* initialise */
plow=daily_low[1];
phigh=daily_high[1];

for(i=1;i<DAYS;i++)
{
   if(plow>daily_low[i])
   {
      plow =daily_low[i];
   }
}

for(i=1;i<DAYS;i++)
{
   if(phigh<daily_high[i])
   {
      phigh =daily_high[i];
   }
}

Comment("\n",DAYS,"DayH ",phigh,"\n",DAYS,"DayL ",plow);

ObjectDelete("DayHigh");
ObjectDelete("DayLow");

ObjectCreate("DayHigh",OBJ_HLINE,0,CurTime(),phigh);
ObjectSet("DayHigh",OBJPROP_COLOR,HighColor);
ObjectSet("DayHigh",OBJPROP_STYLE,HighStyle);

ObjectCreate("DayLow",OBJ_HLINE,0,CurTime(),plow);
ObjectSet("DayLow",OBJPROP_COLOR,LowColor);
ObjectSet("DayLow",OBJPROP_STYLE,LowStyle);

ObjectsRedraw();

   return(0);
  }
//+------------------------------------------------------------------